package main

import (
	"crypto/aes"
	"crypto/cipher"
	"encoding/base64"
	"errors"
	"log"
	"os"
	"strings"
)

func main() {
	key := os.Args[1]
	value := os.Args[2]
	log.Println(aesDec(key, value))
}

func aesDec(key, payload string) (string, error) {
	if len(key) == 0 {
		return "", errors.New("key required")
	}
	key = strings.Repeat(key, 32)[:32]

	ciphertext, err := base64.StdEncoding.DecodeString(payload)
	if err != nil {
		return "", err
	}

	block, err := aes.NewCipher([]byte(key))
	if err != nil {
		return "", err
	}
	gcm, err := cipher.NewGCM(block)
	if err != nil {
		return "", err
	}
	log.Println(gcm.NonceSize())
	if len(ciphertext) < gcm.NonceSize() {
		return "", errors.New("short ciphertext")
	}
	b, err := gcm.Open(nil, ciphertext[:gcm.NonceSize()], ciphertext[gcm.NonceSize():], nil)
	return string(b), err
}
